-- Pin by Jadya
-- EU - Well of Eternity

local addonName, addonTable = ...
local L = addonTable.L

local settings = addonTable.settings
local notes = addonTable.NoteFunctions

settings.backdrop = {
                  bgFile = "Interface\\Buttons\\GreyscaleRamp64", 
                  edgeFile = "Interface\\Buttons\\WHITE8X8", 
                  edgeSize = 1
                 }

local initialized, mf, editing_note

local function save_colors()
 notes:SaveColors(editing_note)
end

local function Initialize()

 local f, p

 mf = CreateFrame("Frame", "PinSettingsFrame", UIParent)
 mf:SetFrameStrata("DIALOG")
 mf:EnableMouse(true)
 mf:SetMovable(true)
 mf:RegisterForDrag("LeftButton")
 mf:SetScript("OnDragStart", function(self) self:StartMoving() end)
 mf:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
 mf:SetSize(550, 310)
 mf:SetPoint("CENTER")
 mf:SetBackdrop(settings.backdrop)
 mf:SetBackdropColor(0.04, 0.04, 0.05, 1)
 mf:SetBackdropBorderColor(0.2, 0.2, 0.2, 1)
 
 mf.logo = mf:CreateTexture()
 mf.logo:SetPoint("TOPRIGHT")
 mf.logo:SetSize(130,100)
 mf.logo:SetTexture("Interface\\Addons\\Pin\\logo.tga")
 
 -- tabframe
 f = CreateFrame("Frame", nil, mf)
 f:SetPoint("TOPLEFT", mf, "TOPLEFT", 2, -60)
 f:SetPoint("BOTTOMRIGHT", mf, "BOTTOMRIGHT", -2)
 mf.tabframe = f

 -- appearance
 mf.btn_appearance = CreateFrame("Button", nil, mf.tabframe, "SaregonTabButton")
 mf.btn_appearance:SetText(APPEARANCE_LABEL)
 tab = mf.btn_appearance.tab
 
 -- appearance->note
 local g1 = CreateFrame("Frame", nil, tab, "SaregonGroupbox")
 g1:SetSize(180,180)
 g1:SetPoint("TOPLEFT", tab, "TOPLEFT", 2, -20)
 g1.text:SetText(L["note"])

 f = CreateFrame("Frame", "PinSettingsAppearanceNoteBG", g1, "SaregonColorButton")
 f:SetSize(20, 20)
 f:SetPoint("TOPLEFT", g1, "TOPLEFT", 5, -5)
 f.mode = "backdrop"
 f.func = save_colors
 f:SetText(L["background_color"])
 
 f = CreateFrame("Frame", "PinSettingsAppearanceNoteBorder", g1, "SaregonColorButton")
 f:SetSize(20, 20)
 f:SetPoint("TOPLEFT", g1, "TOPLEFT", 5, -30)
 f.mode = "backdrop_border"
 f.func = save_colors
 f:SetText(EMBLEM_BORDER_COLOR)

 f = CreateFrame("Slider", "PinSettingsAppearanceNoteWidth", g1, "SaregonSliderH")
 f:SetPoint("TOP", g1, "TOP", 0, -65)
 f:SetText(COMPACT_UNIT_FRAME_PROFILE_FRAMEWIDTH)
 f:SetMinMaxValues(90, 350)
 f:SetValue(300)
 f.onValueChanged = function(self)
                     notes:SetMaxWidth(editing_note, self:GetValue())
                    end

 -- appearance->pin
 local g2 = CreateFrame("Frame", nil, tab, "SaregonGroupbox")
 g2:SetSize(180,180)
 g2:SetPoint("LEFT", g1, "RIGHT", 1, 0)
 g2.text:SetText(L["pin"])
 
 f = CreateFrame("Frame", "PinSettingsAppearancePinBG", g2, "SaregonColorButton")
 f:SetSize(20, 20)
 f:SetPoint("TOPLEFT", g2, "TOPLEFT", 5, -5)
 f.mode = "backdrop"
 f:SetText(L["background_color"])
 f.func = save_colors
 
 f = CreateFrame("Frame", "PinSettingsAppearancePinBorder", g2, "SaregonColorButton")
 f:SetSize(20, 20)
 f:SetPoint("TOPLEFT", g2, "TOPLEFT", 5, -30)
 f.mode = "backdrop_border"
 f:SetText(EMBLEM_BORDER_COLOR)
 f.func = save_colors

 f = CreateFrame("Slider", "PinSettingsAppearancePinWidth", g2, "SaregonSliderH")
 f:SetPoint("TOP", g2, "TOP", 0, -65)
 f:SetText(COMPACT_UNIT_FRAME_PROFILE_FRAMEWIDTH)
 f:SetMinMaxValues(20, 130)
 f:SetValue(200)
 f.onValueChanged = function(self)
                     notes:SetPinWidth(editing_note, self:GetValue())
                    end

 f = CreateFrame("Slider", "PinSettingsAppearancePinHeight", g1, "SaregonSliderH")
 f:SetPoint("TOP", g2, "TOP", 0, -105)
 f:SetText(COMPACT_UNIT_FRAME_PROFILE_FRAMEHEIGHT)
 f:SetMinMaxValues(20, 130)
 f:SetValue(100)
 f.onValueChanged = function(self)
                     notes:SetPinHeight(editing_note, self:GetValue())
                    end

 -- appearance->font
 local g3 = CreateFrame("Frame", nil, tab, "SaregonGroupbox")
 g3:SetSize(180,180)
 g3:SetPoint("LEFT", g2, "RIGHT", 1, 0)
 g3.text:SetText(L["font"])

 f = CreateFrame("Frame", "PinSettingsAppearanceFontColor", g3, "SaregonColorButton")
 f:SetSize(20, 20)
 f:SetPoint("TOPLEFT", g3, "TOPLEFT", 5, -5)
 f.mode = "fontstring"
 f:SetText(COLOR)
 f.func = save_colors
 
 f = CreateFrame("Slider", "PinSettingsAppearanceFontSize", g3, "SaregonSliderH")
 f:SetPoint("TOP", g3, "TOP", 0, -65)
 f:SetText(L["size"])
 f:SetMinMaxValues(4, 30)
 f:SetValue(12)
 f.onValueChanged = function(self)
				     notes:SetFont(editing_note, "Fonts\\FRIZQT__.TTF", self:GetValue())
                    end

 -- general
 mf.btn_general = CreateFrame("Button", nil, mf.tabframe, "SaregonTabButton")
 mf.btn_general:SetText(GENERAL)
 tab = mf.btn_general.tab

 local function setvar(self)
  notes:SetAttr(editing_note, self.key, self.tag)
 end
 
 -- appearance->note
 g1 = CreateFrame("Frame", nil, tab, "SaregonGroupbox")
 g1:SetSize(170,70)
 g1:SetPoint("TOPLEFT", tab, "TOPLEFT", 2, -20)
 g1.text:SetText(L["combat_behavior"])

 f = CreateFrame("Checkbutton", "PinSettingsGeneralCombatShow", g1, "SaregonRadiobutton")
 f:SetPoint("TOPLEFT", g1, "TOPLEFT", 0, 0)
 f:SetText(PLAYER_DIFFICULTY1)
 f.key = "combat_behavior"
 f.tag = 0
 f.func = setvar
 
 f = CreateFrame("Checkbutton", "PinSettingsGeneralCombatHide", g1, "SaregonRadiobutton")
 f:SetPoint("TOPLEFT", g1, "TOPLEFT", 0, -20)
 f:SetText(HIDE)
 f.key = "combat_behavior"
 f.tag = 1
 f.func = setvar

 f = CreateFrame("Checkbutton", "PinSettingsGeneralCombatClickThrough", g1, "SaregonRadiobutton")
 f:SetPoint("TOPLEFT", g1, "TOPLEFT", 0, -40)
 f:SetText(L["click-through"])
 f.key = "combat_behavior"
 f.tag = 2
 f.func = setvar
 
 -- close button
 f = CreateFrame("Button", nil, mf, "SaregonButton")
 f:SetPoint("BOTTOM", mf, "BOTTOM", 0, 10)
 f:SetText(CLOSE)
 f:SetScript("OnClick", function()
   mf:Hide()
  end)
 f:SetScript("OnHide", function()
   if PinMainframeGroupsList and PinMainframeGroupsList:IsVisible() then
    PinMainframeGroupsList:update()
   end
   if PinMainframePinsList and PinMainframePinsList:IsVisible() then
    PinMainframePinsList:update()
   end
 end)

 SaregonWidgets:TabButton_OnClick(mf.btn_appearance)

 initialized = true
end

local function NoteToFrame(note)
 -- appearance
 PinSettingsAppearanceNoteBG.tag = editing_note
 SaregonWidgets:ColorButton_UpdateColor(PinSettingsAppearanceNoteBG, editing_note:GetBackdropColor())
 
 PinSettingsAppearanceNoteBorder.tag = editing_note 
 SaregonWidgets:ColorButton_UpdateColor(PinSettingsAppearanceNoteBorder, editing_note:GetBackdropBorderColor())
 
 PinSettingsAppearancePinBG.tag = editing_note.pin 
 SaregonWidgets:ColorButton_UpdateColor(PinSettingsAppearancePinBG, editing_note.pin:GetBackdropColor())
 
 PinSettingsAppearancePinBorder.tag = editing_note.pin
 SaregonWidgets:ColorButton_UpdateColor(PinSettingsAppearancePinBorder, editing_note.pin:GetBackdropBorderColor())
 
 PinSettingsAppearanceFontColor.tag = editing_note.text
 SaregonWidgets:ColorButton_UpdateColor(PinSettingsAppearanceFontColor, editing_note.text:GetTextColor())

 PinSettingsAppearanceNoteWidth:SetValue(editing_note.maxWidth)
 PinSettingsAppearancePinWidth:SetValue(editing_note.pin:GetWidth())
 PinSettingsAppearancePinHeight:SetValue(editing_note.pin:GetHeight())
 PinSettingsAppearanceFontSize:SetValue(select(2, editing_note.text:GetFont()))
 
 -- general
 PinSettingsGeneralCombatShow:SetChecked(editing_note.combat_behavior == 0)
 PinSettingsGeneralCombatHide:SetChecked(editing_note.combat_behavior == 1)
 PinSettingsGeneralCombatClickThrough:SetChecked(editing_note.combat_behavior == 2)
end

function settings:EditNote(note)
 if not initialized then Initialize() end
 
 NoteToFrame(note)
 mf:Hide() -- force onhide script to update other frames
 mf:Show()
end

local menuframe = CreateFrame("Frame", "PinMenuFrame", UIParent, "UIDropDownMenuTemplate")
local settings_menu = {
                       { text = SETTINGS, notCheckable = true, func = function() settings:EditNote(editing_note) end },
					   { text = " ", isTitle = true, notCheckable = true}, 
					   --{ text = "Delete", notCheckable = true, func = function() notes:Delete(editing_note) end },
					   --{ text = " ", isTitle = true, notCheckable = true}, 
					   { text = CLOSE, notCheckable = true}, 
                      }

function Pin_Settings(note)
 editing_note = note
 EasyMenu(settings_menu, menuframe, note.pin, 0, 0)
end




